// stereo.cpp : Defines the entry point for the console application.
//

//-------------------------------------------------------------------------
//				  PRESENTATION
//-------------------------------------------------------------------------

/* Ce programme va faire passer les images en niveaux de gris.
Il va aussi harmoniser les couleurs de l'image, ce qui va augmenter les contrastes et faciliter les traitements futurs.*/

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

void stereo(void);
int recdonneesimage(int);
void remplircouleurs(int *,int *,int *,int *,int *,int *,int);
void imageniveauxgris(int *,int *,int *,int *,int,int,int,int,int);
void initialise (char *,int);
void egalhisto(int *,int *,int *,int *,int *,int *,int);
void imageegal(int,int,int,int,int *,int *,int *,int *,int *,int *);
void copiedisque(int,int,int,int,int *,int *,int *,int *,int *,int *,int *,int *,int *,int *);

//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------

void main (void)
{	
	stereo();
}

 //-------------------------------------------------------------------------
 //                               STEREOVISION
 //---------------------------------------------------------------------------

void stereo (void)
{
	int largeur,hauteur,taillefichier,tailleimage;
	int *tableauR,*tableauG,*tableauB,*tableauRd,*tableauGd,*tableauBd;
	int *tableauniveaugris,*tableauniveaugrisegal,*tableauniveaugris_d,*tableauniveaugrisegal_d;

	largeur=recdonneesimage(0);
	hauteur=recdonneesimage(1);
	taillefichier=recdonneesimage(2);
	tailleimage=recdonneesimage(3);
	tableauR=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauG=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauB=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauRd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauGd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauBd=(int *) malloc (sizeof(int)*(largeur*hauteur));
	remplircouleurs(tableauR,tableauG,tableauB,tableauRd,tableauGd,tableauBd,largeur*hauteur);

	printf("                       ETAPE 2\n");
	printf("        Egalisation de l'histogramme\n\n");
	tableauniveaugris=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauniveaugris_d=(int *) malloc (sizeof(int)*(largeur*hauteur));
	imageniveauxgris(tableauniveaugris,tableauR,tableauG,tableauB,largeur,hauteur,tailleimage,taillefichier,1);
	imageniveauxgris(tableauniveaugris_d,tableauRd,tableauGd,tableauBd,largeur,hauteur,tailleimage,taillefichier,3);
	egalhisto(tableauR,tableauG,tableauB,tableauRd,tableauGd,tableauBd,largeur*hauteur);
	tableauniveaugrisegal=(int *) malloc (sizeof(int)*(largeur*hauteur));
	tableauniveaugrisegal_d=(int *) malloc (sizeof(int)*(largeur*hauteur));
	imageniveauxgris(tableauniveaugrisegal,tableauR,tableauG,tableauB,largeur,hauteur,tailleimage,taillefichier,2);
	imageniveauxgris(tableauniveaugrisegal_d,tableauRd,tableauGd,tableauBd,largeur,hauteur,tailleimage,taillefichier,4);
	imageegal(taillefichier,tailleimage,largeur,hauteur,tableauR,tableauG,tableauB,tableauRd,tableauGd,tableauBd);
	copiedisque(taillefichier,tailleimage,largeur,hauteur,tableauR,tableauRd,tableauB,tableauBd,tableauG,tableauGd,tableauniveaugris,tableauniveaugrisegal,tableauniveaugris_d,tableauniveaugrisegal_d);

	printf("Fin Partie 2 \n\n");
//	getch();
}


 //-------------------------------------------------------------------------
 //                               RECUPERATION DE LA TAILLE FICHIER
 //---------------------------------------------------------------------------

int recdonneesimage(int variable)
{
	FILE *nomfichier;
	int taillefichier,tailleimage,largeur,hauteur;

	nomfichier=fopen("donnees_images/description.txt","r");
	fscanf(nomfichier,"%d",&taillefichier);
	fscanf(nomfichier,"%d",&tailleimage);
	fscanf(nomfichier,"%d",&largeur);
	fscanf(nomfichier,"%d",&hauteur);
	fclose(nomfichier);

	if(variable==0)
		return largeur;
	if(variable==1)
		return hauteur;
	if(variable==2)
		return taillefichier;
	if(variable==3)
		return tailleimage;
	else
		return -1;
}


 //-------------------------------------------------------------------------
 //                               RECUPERATION DES COULEURS
 //---------------------------------------------------------------------------

void remplircouleurs(int *tableauR,int *tableauG,int *tableauB,int *tableauRd,int *tableauGd,int *tableauBd,int taille)
{
	FILE *nomfichier;
	int i;

	nomfichier=fopen("tableaux/couleurRg.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&tableauR[i]);
	fclose(nomfichier);

	nomfichier=fopen("tableaux/couleurGg.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&tableauG[i]);
	fclose(nomfichier);

	nomfichier=fopen("tableaux/couleurBg.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&tableauB[i]);
	fclose(nomfichier);

	nomfichier=fopen("tableaux/couleurRd.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&tableauRd[i]);
	fclose(nomfichier);

	nomfichier=fopen("tableaux/couleurGd.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&tableauGd[i]);
	fclose(nomfichier);

	nomfichier=fopen("tableaux/couleurBd.txt","r");
	for(i=0;i<taille;i++)
		fscanf(nomfichier,"%d",&tableauBd[i]);
	fclose(nomfichier);
}

 //-------------------------------------------------------------------------
 //                               CREER UNE IMAGE EN NIVEAUX DE GRIS
 //---------------------------------------------------------------------------

void imageniveauxgris(int *tableauniveaugris,int *tableauR,int *tableauG,int *tableauB,int largeur,int hauteur,int tailleimage,int taillefichier,int variable)
{
	int i,j,taille;
	FILE *nomfichier;
	char *entete;
	unsigned char copie[2];

	taille=largeur*hauteur;
	for(i=0;i<taille;i++)
		tableauniveaugris[i]=(int)((tableauR[i]+tableauG[i]+tableauB[i])/3);

	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
   	nomfichier=fopen("images_originales/image_g.bmp","r");
	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	if(variable==1)
	{
		nomfichier=fopen("images_traitees/image_g_niveaux_gris.bmp","w");
		fclose(nomfichier);
	
		nomfichier=fopen("images_traitees/image_g_niveaux_gris.bmp","w");
	}

	if(variable==2)
	{
		nomfichier=fopen("images_traitees/image_g_niveaux_gris_egalisee.bmp","w");
		fclose(nomfichier);
	
		nomfichier=fopen("images_traitees/image_g_niveaux_gris_egalisee.bmp","w");
	}

	if(variable==3)
	{
		nomfichier=fopen("images_traitees/image_d_niveaux_gris.bmp","w");
		fclose(nomfichier);
	
		nomfichier=fopen("images_traitees/image_d_niveaux_gris.bmp","w");
	}

	if(variable==4)
	{
		nomfichier=fopen("images_traitees/image_d_niveaux_gris_egalisee.bmp","w");
		fclose(nomfichier);
	
		nomfichier=fopen("images_traitees/image_d_niveaux_gris_egalisee.bmp","w");
	}	

	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
		{
			entete[i]=11;
			printf("Attention, penser a modifier le caractere %d de l'entete\n",i+1);
			/* Avec Windows, le caractre 10 est automatiquement associ  un autre caractre.
			Aussi, pour viter de se retrouver avec 2 caractres, il est ncessaire de remplacer le caractre par un autre.
			Avec un diteur hexa, il faut ensuite remplacer le caractre 11 par un 10 pour que l'image soit correcte.*/
		}
		fprintf(nomfichier,"%c",entete[i]);
	}

	copie[1]='\0';

	if((largeur%4)==0)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
		}
	}

	if((largeur%4)==1)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==2)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
		}
	}

	if((largeur%4)==3)
	{
		for(i=0;i<hauteur;i++)
		{
			for(j=0;j<largeur;j++)
			{
				copie[0]=tableauniveaugris[i*largeur+j];
				if(copie[0]==10)
					copie[0]=11;
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
				fprintf(nomfichier,"%c",copie[0]);
			}
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
			fprintf(nomfichier,"%c",copie[1]);
		}
	}
	fclose(nomfichier);
	free(entete);
}



 //-------------------------------------------------------------------------
 //                               INITIALISE TABLEAU
 //---------------------------------------------------------------------------

void initialise (char *entete, int M)
{
	int	i=0;
	for(i=0;i<M;i++)
		entete[i]='\0';
}

 //-------------------------------------------------------------------------
 //                               EGALISATION COULEURS
 //---------------------------------------------------------------------------
void egalhisto(int *tableauR,int *tableauG,int *tableauB,int *tableauRd,int *tableauGd,int *tableauBd,int taille)
{
	long int histocumule[256],histo;
	int i;

	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<taille;i++)
		histocumule[tableauR[i]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<taille;i++)
	{
		histo=histocumule[tableauR[i]];
		tableauR[i]=(int)((histo*255)/taille);
	}

	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<taille;i++)
		histocumule[tableauG[i]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<taille;i++)
	{
		histo=histocumule[tableauG[i]];
		tableauG[i]=(int)((histo*255)/taille);
	}

	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<taille;i++)
		histocumule[tableauB[i]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<taille;i++)
	{
		histo=histocumule[tableauB[i]];
		tableauB[i]=(int)((histo*255)/taille);
	}

	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<taille;i++)
		histocumule[tableauRd[i]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<taille;i++)
	{
		histo=histocumule[tableauRd[i]];
		tableauRd[i]=(int)((histo*255)/taille);
	}

	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<taille;i++)
		histocumule[tableauGd[i]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<taille;i++)
	{
		histo=histocumule[tableauGd[i]];
		tableauGd[i]=(int)((histo*255)/taille);
	}

	for(i=0;i!=256;i++)
		histocumule[i]=0;
	for(i=0;i<taille;i++)
		histocumule[tableauBd[i]]++;
	for(i=1;i!=256;i++)
		histocumule[i]=histocumule[i-1]+histocumule[i];
	for(i=0;i<taille;i++)
	{
		histo=histocumule[tableauBd[i]];
		tableauBd[i]=(int)((histo*255)/taille);
	}

}



 //-------------------------------------------------------------------------
 //                               REALISATION DES IMAGES EGALISEES
 //---------------------------------------------------------------------------


void imageegal(int taillefichier,int tailleimage,int largeur,int hauteur,int *tableauR,int *tableauG,int *tableauB,int *tableauRd,int *tableauGd,int *tableauBd)
{
	FILE *nomfichier;
	char *entete;
	unsigned char copieR[2],copieG[2],copieB[2];
	int i,j;
	entete=(char *) malloc (sizeof(char)*(taillefichier-tailleimage));
	nomfichier=fopen("images_originales/image_g.bmp","r");

	initialise(entete,taillefichier-tailleimage);
	fread(entete,taillefichier-tailleimage,1,nomfichier);
	fclose(nomfichier);

	nomfichier=fopen("images_traitees/image_g_egalisee.bmp","w");
	fclose(nomfichier);
	
	nomfichier=fopen("images_traitees/image_g_egalisee.bmp","aw");
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}

	copieR[1]='\0';
	copieG[1]='\0';
	copieB[1]='\0';

	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{
			copieR[0]=tableauR[i*largeur+j];
			copieG[0]=tableauG[i*largeur+j];
			copieB[0]=tableauB[i*largeur+j];
			if(copieR[0]==10)
				copieR[0]=11;
			if(copieG[0]==10)
				copieG[0]=11;
			if(copieB[0]==10)
				copieB[0]=11;
			fprintf(nomfichier,"%c",copieB[0]);
			fprintf(nomfichier,"%c",copieG[0]);
			fprintf(nomfichier,"%c",copieR[0]);
		}
		if((largeur%4)==1)
		{
			fprintf(nomfichier,"%c",copieB[1]);
		}
		if((largeur%4)==2)
		{
			fprintf(nomfichier,"%c",copieB[1]);
			fprintf(nomfichier,"%c",copieB[1]);
		}
		if((largeur%4)==3)
		{
			fprintf(nomfichier,"%c",copieB[1]);
			fprintf(nomfichier,"%c",copieB[1]);
			fprintf(nomfichier,"%c",copieB[1]);
		}		
	}


	fclose(nomfichier);


	nomfichier=fopen("images_traitees/image_d_egalisee.bmp","w");
	fclose(nomfichier);
	
	nomfichier=fopen("images_traitees/image_d_egalisee.bmp","aw");
	for(i=0;i<taillefichier-tailleimage;i++)
	{
		if(entete[i]==10)
			entete[i]=11;
		fprintf(nomfichier,"%c",entete[i]);
	}


	for(i=0;i<hauteur;i++)
	{
		for(j=0;j<largeur;j++)
		{
			copieR[0]=tableauRd[i*largeur+j];
			copieG[0]=tableauGd[i*largeur+j];
			copieB[0]=tableauBd[i*largeur+j];
			if(copieR[0]==10)
				copieR[0]=11;
			if(copieG[0]==10)
				copieG[0]=11;
			if(copieB[0]==10)
				copieB[0]=11;
			fprintf(nomfichier,"%c",copieB[0]);
			fprintf(nomfichier,"%c",copieG[0]);
			fprintf(nomfichier,"%c",copieR[0]);
		}
		if((largeur%4)==1)
		{
			fprintf(nomfichier,"%c",copieB[1]);
		}
		if((largeur%4)==2)
		{
			fprintf(nomfichier,"%c",copieB[1]);
			fprintf(nomfichier,"%c",copieB[1]);
		}
		if((largeur%4)==3)
		{
			fprintf(nomfichier,"%c",copieB[1]);
			fprintf(nomfichier,"%c",copieB[1]);
			fprintf(nomfichier,"%c",copieB[1]);
		}
	}

	fclose(nomfichier);
	free(entete);
}


 //-------------------------------------------------------------------------
 //                          COPIE DONNEES SUR LE DISQUE DUR
 //---------------------------------------------------------------------------
void copiedisque(int taillefichier,int tailleimage,int largeur,int hauteur,int *tableauR,int *tableauRd,int *tableauB,int *tableauBd,int *tableauG,int *tableauGd,int* tableauniveaugris,int *tableauniveaugrisegal,int* tableauniveaugris_d,int *tableauniveaugrisegal_d)
{
	FILE *nomfichier;
	int i;

   	nomfichier=fopen("donnees_images/description.txt","w");
	fprintf(nomfichier,"%d\n",taillefichier);
	fprintf(nomfichier,"%d\n",tailleimage);
	fprintf(nomfichier,"%d\n",largeur);
	fprintf(nomfichier,"%d\n",hauteur);
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurRg_egalisee.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauR[i]<0)
			tableauR[i]=256+tableauR[i];
		fprintf(nomfichier,"%d\n",tableauR[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurRd_egalisee.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauRd[i]<0)
			tableauRd[i]=256+tableauRd[i];
		fprintf(nomfichier,"%d\n",tableauRd[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurGg_egalisee.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauG[i]<0)
			tableauG[i]=256+tableauG[i];
		fprintf(nomfichier,"%d\n",tableauG[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurGd_egalisee.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauGd[i]<0)
			tableauGd[i]=256+tableauGd[i];
		fprintf(nomfichier,"%d\n",tableauGd[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurBg_egalisee.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauB[i]<0)
			tableauB[i]=256+tableauB[i];
		fprintf(nomfichier,"%d\n",tableauB[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/couleurBd_egalisee.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauBd[i]<0)
			tableauBd[i]=256+tableauBd[i];
		fprintf(nomfichier,"%d\n",tableauBd[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/niveau_gris_g.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauniveaugris[i]<0)
			tableauniveaugris[i]=256+tableauniveaugris[i];
		fprintf(nomfichier,"%d\n",tableauniveaugris[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/niveau_gris_egalisee_g.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauniveaugrisegal[i]<0)
			tableauniveaugrisegal[i]=256+tableauniveaugrisegal[i];
		fprintf(nomfichier,"%d\n",tableauniveaugrisegal[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/niveau_gris_d.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauniveaugris_d[i]<0)
			tableauniveaugris_d[i]=256+tableauniveaugris_d[i];
		fprintf(nomfichier,"%d\n",tableauniveaugris_d[i]);
	}
	fclose(nomfichier);

   	nomfichier=fopen("tableaux/niveau_gris_egalisee_d.txt","w");
	for(i=0;i<largeur*hauteur;i++)
	{
		if(tableauniveaugrisegal_d[i]<0)
			tableauniveaugrisegal_d[i]=256+tableauniveaugrisegal_d[i];
		fprintf(nomfichier,"%d\n",tableauniveaugrisegal_d[i]);
	}
	fclose(nomfichier);

}