// stereo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

void stereo(void);
void remplirdisparite(int *,int);
int	calcul(int *disparite,int largeur,int hauteur,int x,int y);
int recdonneesimage(int);

//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------
void main (void)
{	
	stereo();
}

//-------------------------------------------------------------------------
//                               STEREOVISION
//---------------------------------------------------------------------------
void stereo (void)
{
	int largeur,hauteur,x,y,disparitepixel;
	int *disparite;

	largeur=recdonneesimage(0);
	hauteur=recdonneesimage(1);

	disparite=(int *) malloc (sizeof(int)*(largeur*hauteur));
	remplirdisparite(disparite,largeur*hauteur);


	printf("\nposition sur x du pixel : ");
	scanf("%d",&x);
	printf("position sur y du pixel : ");
	scanf("%d",&y);

	disparitepixel=calcul(disparite,largeur,hauteur,x,y);
	printf("disparite du pixel = %d\n\n",disparitepixel);

	free(disparite);
	printf("(appuyer sur une touche pour quitter)\n");
	getch();
}


//-------------------------------------------------------------------------
//                               RECUPERATION DISPARITE
//---------------------------------------------------------------------------
void remplirdisparite(int *disparite,int taille)
{
	FILE *nomfichier;
	int i;

		nomfichier=fopen("tableaux/disparite.txt","r");
		for(i=0;i<taille;i++)
			fscanf(nomfichier,"%d",&disparite[i]);
		fclose(nomfichier);
}

int	calcul(int *disparite,int largeur,int hauteur,int x,int y)
{

	return disparite[y*largeur+x];
}



//-------------------------------------------------------------------------
//                               RECUPERATION DES DONNEES DU FICHIER
//---------------------------------------------------------------------------
// Cette fonction permet de rcuprer des donnes sur les images,  savoir la largeur, hauteur, taille totale du fichier et taille totale de l'image.
int recdonneesimage(int variable)
{
	FILE *nomfichier;
	int taillefichier,tailleimage,largeur,hauteur;

	nomfichier=fopen("donnees_images/description.txt","r");
	fscanf(nomfichier,"%d",&taillefichier);
	fscanf(nomfichier,"%d",&tailleimage);
	fscanf(nomfichier,"%d",&largeur);
	fscanf(nomfichier,"%d",&hauteur);
	fclose(nomfichier);
	if(variable==0)
		return largeur;
	if(variable==1)
		return hauteur;

	else
		return -1;
}